commit 65d2537d658b99b005a18c6663bc1293b41a1d83
Author: Martin Helmling <martin.helmling@octosoft.eu>
Date:   Thu Dec 22 08:37:45 2016 +0100

    Artikel-Klassifizierung
    
        Die Klassifizierung von Artikeln dient einer weiteren Gliederung um zum Beispiel den Einkauf vom Verkauf zu trennen, etc.
    
        Gekennzeichnet durch eine Beschreibung (z.B. "Einkauf") und ein Kürzel (z.B. "E")
        Flexibel änderbar und erweiterbar.
    
        - Neue Datenbanktablle und Rose-Objekte, sowie Controller zum Bearbeiten der Tabelle
    
        - Zwei-Zeichen Abkürzung:
    
        Der Typ des Artikel und die Klassifizierung werden durch zwei Buchstaben dargestellt.
        Der erste Buchstabe  ist eine Lokalisierung des Typs des Artikel ('P','A','S') ,
        deutch 'W', 'E', und 'D' für Ware Erzeugnis oder Dienstleistung, ggf. weitere Typen.
        Der zweite Buchstabe ist eine Lokalisierung der Klassifizierungsabkürzung (abbreviation).
    
        Die Abkürzungen sind aus dem Part Presenter abholbar:
        -  SL::Presenter::Part->type_abbreviation($part_type)
        -  SL::Presenter::Part->classification_abbreviation($classification_id)
    
        Anpassung des CSV Import,
        nun wird alternativ zur 'part_type'-Spalte die 'pclass'-Spalte mit zwei Buchstaben geparsed und entsprechend
        classification_id, part_type gesetzt.

diff --git a/SL/Controller/CsvImport/Part.pm b/SL/Controller/CsvImport/Part.pm
index ef7e2389a..069dad2bd 100644
--- a/SL/Controller/CsvImport/Part.pm
+++ b/SL/Controller/CsvImport/Part.pm
@@ -23,7 +23,7 @@ use parent qw(SL::Controller::CsvImport::Base);
 use Rose::Object::MakeMethods::Generic
 (
  scalar                  => [ qw(table makemodel_columns) ],
- 'scalar --get_set_init' => [ qw(bg_by settings parts_by price_factors_by units_by partsgroups_by
+ 'scalar --get_set_init' => [ qw(bg_by settings parts_by price_factors_by classification_by units_by partsgroups_by
                                  warehouses_by bins_by
                                  translation_columns all_pricegroups) ],
 );
@@ -40,6 +40,7 @@ sub set_profile_defaults {
                        article_number_policy     => 'update_prices',
                        shoparticle_if_missing    => '0',
                        part_type                 => 'part',
+                       part_classification       => 0,
                        default_buchungsgruppe    => ($bugru ? $bugru->id : undef),
                        apply_buchungsgruppe      => 'all',
                       );
@@ -58,6 +59,13 @@ sub init_bg_by {
   return { map { my $col = $_; ( $col => { map { ( $_->$col => $_ ) } @{ $all_bg } } ) } qw(id description) };
 }
 
+sub init_classification_by {
+  my ($self) = @_;
+  my $all_classifications = SL::DB::Manager::PartClassification->get_all;
+  $_->abbreviation($::locale->text($_->abbreviation)) for @{ $all_classifications };
+  return { map { my $col = $_; ( $col => { map { ( $_->$col => $_ ) } @{ $all_classifications } } ) } qw(id abbreviation) };
+}
+
 sub init_price_factors_by {
   my ($self) = @_;
 
@@ -126,7 +134,7 @@ sub init_settings {
 
   return { map { ( $_ => $self->controller->profile->get($_) ) } qw(apply_buchungsgruppe default_buchungsgruppe article_number_policy
                                                                     sellprice_places sellprice_adjustment sellprice_adjustment_type
-                                                                    shoparticle_if_missing part_type default_unit) };
+                                                                    shoparticle_if_missing part_type classification_id default_unit) };
 }
 
 sub init_all_cvar_configs {
@@ -174,7 +182,7 @@ sub check_objects {
     $i++;
   }
 
-  $self->add_columns(qw(part_type)) if $self->settings->{part_type} eq 'mixed';
+  $self->add_columns(qw(part_type classification_id)) if $self->settings->{part_type} eq 'mixed';
   $self->add_columns(qw(buchungsgruppen_id unit));
   $self->add_columns(map { "${_}_id" } grep { exists $self->controller->data->[0]->{raw_data}->{$_} } qw (price_factor payment partsgroup warehouse bin));
   $self->add_columns(qw(shop)) if $self->settings->{shoparticle_if_missing};
@@ -413,12 +421,30 @@ sub check_part_type {
   # $bg  ||= SL::DB::Buchungsgruppe->new(inventory_accno_id => 1); # does this case ever occur?
 
   my $part_type = $self->settings->{part_type};
-  if ($part_type eq 'mixed') {
-    $part_type = $entry->{raw_data}->{part_type} =~ m/^p/i ? 'part'
-               : $entry->{raw_data}->{part_type} =~ m/^s/i ? 'service'
+  if ($part_type eq 'mixed' && $entry->{raw_data}->{part_type}) {
+    $part_type = $entry->{raw_data}->{part_type} =~ m/^p/i     ? 'part'
+               : $entry->{raw_data}->{part_type} =~ m/^s/i     ? 'service'
                : $entry->{raw_data}->{part_type} =~ m/^assem/i ? 'assembly'
                : $entry->{raw_data}->{part_type} =~ m/^assor/i ? 'assortment'
-               : undef;
+               :                                                 $self->settings->{part_type};
+  }
+  my $classification_id = $self->settings->{classification_id};
+
+  if ( $entry->{raw_data}->{pclass} && length($entry->{raw_data}->{pclass}) >= 2 ) {
+    my $abbr1 = substr($entry->{raw_data}->{pclass},0,1);
+    my $abbr2 = substr($entry->{raw_data}->{pclass},1);
+
+    if ( $self->classification_by->{abbreviation}->{$abbr2} ) {
+      my $tmp_classification_id = $self->classification_by->{abbreviation}->{$abbr2}->id;
+      $classification_id = $tmp_classification_id if $tmp_classification_id;
+    }
+    if ($part_type eq 'mixed') {
+      $part_type = $abbr1 eq $::locale->text('Part (typeabbreviation)') ? 'part'
+        : $abbr1 eq $::locale->text('Service (typeabbreviation)')       ? 'service'
+        : $abbr1 eq $::locale->text('Assembly (typeabbreviation)')      ? 'assembly'
+        : $abbr1 eq $::locale->text('Assortment (typeabbreviation)')    ? 'assortment'
+        :                                                                 undef;
+    }
   }
 
   # when saving income_accno_id or expense_accno_id use ids from the selected
@@ -443,6 +469,7 @@ sub check_part_type {
   }
 
   $entry->{object}->part_type($part_type);
+  $entry->{object}->classification_id( $classification_id );
 
   return 1;
 }
@@ -699,8 +726,8 @@ sub setup_displayable_columns {
 
   $self->add_displayable_columns({ name => 'bin_id',             description => $::locale->text('Bin (database ID)')                                    },
                                  { name => 'bin',                description => $::locale->text('Bin (name)')                                           },
-                                 { name => 'buchungsgruppen_id', description => $::locale->text('Booking group (database ID)')                         },
-                                 { name => 'buchungsgruppe',     description => $::locale->text('Booking group (name)')                                },
+                                 { name => 'buchungsgruppen_id', description => $::locale->text('Booking group (database ID)')                          },
+                                 { name => 'buchungsgruppe',     description => $::locale->text('Booking group (name)')                                 },
                                  { name => 'description',        description => $::locale->text('Description')                                          },
                                  { name => 'drawing',            description => $::locale->text('Drawing')                                              },
                                  { name => 'ean',                description => $::locale->text('EAN')                                                  },
@@ -721,18 +748,19 @@ sub setup_displayable_columns {
                                  { name => 'partnumber',         description => $::locale->text('Part Number')                                          },
                                  { name => 'partsgroup_id',      description => $::locale->text('Partsgroup (database ID)')                             },
                                  { name => 'partsgroup',         description => $::locale->text('Partsgroup (name)')                                    },
+                                 { name => 'part_classification',description => $::locale->text('Article classification')  . ' [3]'                     },
                                  { name => 'payment_id',         description => $::locale->text('Payment terms (database ID)')                          },
                                  { name => 'payment',            description => $::locale->text('Payment terms (name)')                                 },
                                  { name => 'price_factor_id',    description => $::locale->text('Price factor (database ID)')                           },
                                  { name => 'price_factor',       description => $::locale->text('Price factor (name)')                                  },
                                  { name => 'rop',                description => $::locale->text('ROP')                                                  },
                                  { name => 'sellprice',          description => $::locale->text('Sellprice')                                            },
-                                 { name => 'shop',               description => $::locale->text('Shop article')                                          },
-                                 { name => 'type',               description => $::locale->text('Article type')  . ' [3]'                             },
+                                 { name => 'shop',               description => $::locale->text('Shop article')                                         },
+                                 { name => 'type',               description => $::locale->text('Article type')  . ' [3]'                               },
                                  { name => 'unit',               description => $::locale->text('Unit (if missing or empty default unit will be used)') },
                                  { name => 've',                 description => $::locale->text('Verrechnungseinheit')                                  },
                                  { name => 'warehouse_id',       description => $::locale->text('Warehouse (database ID)')                              },
-                                 { name => 'warehouse',          description => $::locale->text('Warehouse (name)')                              },
+                                 { name => 'warehouse',          description => $::locale->text('Warehouse (name)')                                     },
                                  { name => 'weight',             description => $::locale->text('Weight')                                               },
                                 );
 
diff --git a/SL/Controller/Inventory.pm b/SL/Controller/Inventory.pm
index c7df4e945..6a7dadc4f 100644
--- a/SL/Controller/Inventory.pm
+++ b/SL/Controller/Inventory.pm
@@ -59,7 +59,6 @@ sub action_stock_usage {
   $self->render('inventory/warehouse_usage',
                 title => $::form->{title},
                 year => DateTime->today->year,
-  #              PARTSCLASSIFICATIONS => SL::DB:Manager::PartsClassification->get_all_classifications_by_name() ,
                 WAREHOUSES => $::form->{WAREHOUSES},
                 WAREHOUSE_FILTER => 1,
                 warehouse_id => 0,
diff --git a/SL/Controller/PartClassification.pm b/SL/Controller/PartClassification.pm
new file mode 100644
index 000000000..5bc4e848f
--- /dev/null
+++ b/SL/Controller/PartClassification.pm
@@ -0,0 +1,229 @@
+package SL::Controller::PartClassification;
+
+use strict;
+
+use parent qw(SL::Controller::Base);
+
+use SL::DB::PartClassification;
+use SL::Helper::Flash;
+
+use Rose::Object::MakeMethods::Generic
+(
+ scalar => [ qw(part_classification) ],
+);
+
+__PACKAGE__->run_before('check_auth');
+__PACKAGE__->run_before('load_part_classification', only => [ qw(edit update destroy) ]);
+
+#
+# This Controller is responsible for creating,editing or deleting
+# Part Classifications.
+#
+# The use of Part Classifications is described in SL::DB::PartClassification
+#
+#
+
+# List all available part classifications
+#
+
+sub action_list {
+  my ($self) = @_;
+
+  $self->render('part_classification/list',
+                title                => $::locale->text('Parts Classifications'),
+                PART_CLASSIFICATIONS => SL::DB::Manager::PartClassification->get_all_sorted);
+}
+
+# A Form for a new creatable part classifications is generated
+#
+sub action_new {
+  my ($self) = @_;
+
+  $self->{part_classification} = SL::DB::PartClassification->new;
+  $self->render('part_classification/form', title => $::locale->text('Create a new parts classification'));
+}
+
+# Edit an existing part classifications
+#
+sub action_edit {
+  my ($self) = @_;
+  $self->render('part_classification/form', title => $::locale->text('Edit parts classification'));
+}
+
+# A new part classification is saved
+#
+sub action_create {
+  my ($self) = @_;
+
+  $self->{part_classification} = SL::DB::PartClassification->new;
+  $self->create_or_update;
+}
+
+# An existing part classification is saved
+#
+sub action_update {
+  my ($self) = @_;
+  $self->create_or_update;
+}
+
+# An existing part classification is deleted
+#
+# The basic classifications cannot be deleted, also classifications which are in use
+#
+sub action_destroy {
+  my ($self) = @_;
+
+  if ( $self->{part_classification}->id < 5 ) {
+    flash_later('error', $::locale->text('The basic parts classification cannot be deleted.'));
+  }
+  elsif (eval { $self->{part_classification}->delete; 1; }) {
+    flash_later('info',  $::locale->text('The parts classification has been deleted.'));
+  } else {
+    flash_later('error', $::locale->text('The parts classification is in use and cannot be deleted.'));
+  }
+
+  $self->redirect_to(action => 'list');
+}
+# reordering the lines
+#
+sub action_reorder {
+  my ($self) = @_;
+
+  SL::DB::PartClassification->reorder_list(@{ $::form->{part_classification_id} || [] });
+
+  $self->render(\'', { type => 'json' });
+}
+
+#
+# filters
+#
+
+# check authentication, only "config" is allowed
+#
+sub check_auth {
+  $::auth->assert('config');
+}
+
+#
+# helpers
+#
+
+# submethod for update the database
+#
+sub create_or_update {
+  my $self   = shift;
+  my $is_new = !$self->{part_classification}->id;
+
+  $::form->{part_classification}->{used_for_purchase} = 0 if ! $::form->{part_classification}->{used_for_purchase};
+  $::form->{part_classification}->{used_for_sale}     = 0 if ! $::form->{part_classification}->{used_for_sale};
+
+  my $params = delete($::form->{part_classification}) || { };
+
+  $self->{part_classification}->assign_attributes(%{ $params });
+
+  my @errors = $self->{part_classification}->validate;
+
+  if (@errors) {
+    flash('error', @errors);
+    $self->render('part_classification/form', title => $is_new ? $::locale->text('Create a new parts classification') : $::locale->text('Edit parts classification'));
+    return;
+  }
+
+  $self->{part_classification}->save;
+
+  flash_later('info', $is_new ? $::locale->text('The parts classification has been created.') : $::locale->text('The parts classification has been saved.'));
+  $self->redirect_to(action => 'list');
+}
+
+# submethod for loading one item from the database
+#
+sub load_part_classification {
+  my ($self) = @_;
+  $self->{part_classification} = SL::DB::PartClassification->new(id => $::form->{id})->load;
+}
+
+1;
+
+
+
+__END__
+
+=encoding utf-8
+
+=head1 NAME
+
+SL::Controller::PartClassification
+
+=head1 SYNOPSIS
+
+This Controller is responsible for creating,editing or deleting
+Part Classifications.
+
+=head1 DESCRIPTION
+
+The use of Part Classifications is described in L<SL::DB::PartClassification>
+
+=head1 METHODS
+
+=head2 action_create
+
+ $self->action_create();
+
+A new part classification is saved
+
+
+
+=head2 action_destroy
+
+ $self->action_destroy();
+
+An existing part classification is deleted
+
+The basic classifications cannot be deleted, also classifications which are in use
+
+
+
+=head2 action_edit
+
+ $self->action_edit();
+
+Edit an existing part classifications
+
+
+
+=head2 action_list
+
+ $self->action_list();
+
+List all available part classifications
+
+
+
+=head2 action_new
+
+ $self->action_new();
+
+A Form for a new creatable part classifications is generated
+
+
+
+=head2 action_reorder
+
+ $self->action_reorder();
+
+reordering the lines
+
+
+
+=head2 action_update
+
+ $self->action_update();
+
+An existing part classification is saved
+
+
+=head1 AUTHOR
+
+Martin Helmling E<lt>martin.helmling@opendynamic.deE<gt>
+
+=cut
diff --git a/SL/DB/Helper/ALL.pm b/SL/DB/Helper/ALL.pm
index bf6bd40df..a896cc372 100644
--- a/SL/DB/Helper/ALL.pm
+++ b/SL/DB/Helper/ALL.pm
@@ -71,6 +71,7 @@ use SL::DB::Object;
 use SL::DB::Order;
 use SL::DB::OrderItem;
 use SL::DB::Part;
+use SL::DB::PartClassification;
 use SL::DB::PartsGroup;
 use SL::DB::PartsPriceHistory;
 use SL::DB::PaymentTerm;
diff --git a/SL/DB/Helper/Mappings.pm b/SL/DB/Helper/Mappings.pm
index 7d1907dfa..3a6f96575 100644
--- a/SL/DB/Helper/Mappings.pm
+++ b/SL/DB/Helper/Mappings.pm
@@ -153,6 +153,7 @@ my %kivitendo_package_names = (
   oe                             => 'order',
   parts                          => 'part',
   partsgroup                     => 'parts_group',
+  part_classifications           => 'PartClassification',
   parts_price_history            => 'PartsPriceHistory',
   payment_terms                  => 'payment_term',
   periodic_invoices              => 'periodic_invoice',
diff --git a/SL/DB/Manager/PartClassification.pm b/SL/DB/Manager/PartClassification.pm
new file mode 100644
index 000000000..0924011e7
--- /dev/null
+++ b/SL/DB/Manager/PartClassification.pm
@@ -0,0 +1,56 @@
+package SL::DB::Manager::PartClassification;
+
+use strict;
+
+use parent qw(SL::DB::Helper::Manager);
+use SL::DB::Helper::Sorted;
+
+sub object_class { 'SL::DB::PartClassification' }
+
+__PACKAGE__->make_manager_methods;
+
+#
+# get the one/two character shortcut of the parts classification
+#
+sub get_abbreviation {
+  my ($class,$id) = @_;
+  my $obj = $class->get_first(query => [ id => $id ]);
+  return '' unless $obj;
+  return $obj->abbreviation?$obj->abbreviation:'';
+}
+
+1;
+
+
+__END__
+
+=encoding utf-8
+
+=head1 NAME
+
+SL::DB::Manager::PartClassification
+
+
+=head1 SYNOPSIS
+
+This class has wrapper methodes to get the shortcuts
+
+=head1 METHODS
+
+=head2 get_abbreviation
+
+ $class->get_abbreviation($classification_id);
+
+get the one/two character shortcut of the parts classification
+
+=head2 get_separate_abbreviation
+
+ $class->get_separate_abbreviation($classification_id);
+
+get the one/two character shortcut of the parts classification if it is a separate article
+
+=head1 AUTHOR
+
+Martin Helmling E<lt>martin.helmling@opendynamic.deE<gt>
+
+=cut
diff --git a/SL/DB/MetaSetup/Part.pm b/SL/DB/MetaSetup/Part.pm
index 65cd85da2..6e758e499 100644
--- a/SL/DB/MetaSetup/Part.pm
+++ b/SL/DB/MetaSetup/Part.pm
@@ -12,6 +12,7 @@ __PACKAGE__->meta->columns(
   bin_id             => { type => 'integer' },
   bom                => { type => 'boolean', default => 'false' },
   buchungsgruppen_id => { type => 'integer' },
+  classification_id  => { type => 'integer', default => '0' },
   description        => { type => 'text' },
   drawing            => { type => 'text' },
   ean                => { type => 'text' },
@@ -63,6 +64,11 @@ __PACKAGE__->meta->foreign_keys(
     key_columns => { buchungsgruppen_id => 'id' },
   },
 
+  classification => {
+    class       => 'SL::DB::PartClassification',
+    key_columns => { classification_id => 'id' },
+  },
+
   partsgroup => {
     class       => 'SL::DB::PartsGroup',
     key_columns => { partsgroup_id => 'id' },
diff --git a/SL/DB/PartClassification.pm b/SL/DB/PartClassification.pm
new file mode 100644
index 000000000..73f11da3c
--- /dev/null
+++ b/SL/DB/PartClassification.pm
@@ -0,0 +1,73 @@
+
+package SL::DB::PartClassification;
+
+use strict;
+
+use SL::DB::MetaSetup::PartClassification;
+use SL::DB::Manager::PartClassification;
+
+__PACKAGE__->meta->initialize;
+
+# check if the description and abbreviation is present
+#
+sub validate {
+  my ($self) = @_;
+
+  my @errors;
+  push @errors, $::locale->text('The description is missing.')  if !$self->description;
+  push @errors, $::locale->text('The abbreviation is missing.') if !$self->abbreviation;
+
+  return @errors;
+}
+
+
+
+1;
+
+__END__
+
+=encoding utf-8
+
+=head1 NAME
+
+SL::DB::PartClassification
+
+=head1 SYNOPSIS
+
+Additional to the article types "part", "assembly", "service" and "assortement"
+the parts classification specifies other ortogonal attributes
+
+=head1 DESCRIPTION
+
+The primary attributes are the rule
+of the article as "used_for_sales" or "used_for_purchase".
+
+Additional other attributes may follow
+
+To see this attributes in a short way there are shortcuts of one (or two characters, if needed for compare )
+which may be translated in the specified language
+
+The type of the article is also as shortcut available, so this combined type and classification shortcut
+is used short as "Type"
+
+English type shortcuts are 'P','A','S'
+German  type shortcuts are 'W','E','D'
+The can set in the language-files
+
+To get the localized abbreviations you can use L<SL::Presenter::Part> .
+
+=head1 METHODS
+
+=head2 validate
+
+ $self->validate();
+
+check if the description and abbreviation is present
+
+
+=head1 AUTHOR
+
+Martin Helmling E<lt>martin.helmling@opendynamic.deE<gt>
+
+
+=cut
diff --git a/SL/IC.pm b/SL/IC.pm
index a39e8ae8d..d352a560d 100644
--- a/SL/IC.pm
+++ b/SL/IC.pm
@@ -92,6 +92,7 @@ sub retrieve_buchungsgruppen {
   $main::lxdebug->leave_sub();
 }
 
+
 sub assembly_item {
   $main::lxdebug->enter_sub();
 
@@ -129,6 +130,7 @@ sub assembly_item {
 
   my $query =
     qq|SELECT p.id, p.partnumber, p.description, p.sellprice,
+       p.classification_id,
        p.weight, p.onhand, p.unit, pg.partsgroup, p.lastcost,
        p.price_factor_id, pfac.factor AS price_factor, p.notes as longdescription
        FROM parts p
@@ -210,7 +212,7 @@ sub all_parts {
 #  my @other_flags          = qw(onhand); # ToDO: implement these
 #  my @inactive_flags       = qw(l_subtotal short l_linetotal);
 
-  my @select_tokens = qw(id factor);
+  my @select_tokens = qw(id factor part_type classification_id);
   my @where_tokens  = qw(1=1);
   my @group_tokens  = ();
   my @bind_vars     = ();
@@ -287,7 +289,7 @@ sub all_parts {
     insertdate         => 'itime::DATE',
   );
 
-  if (($form->{searchitems} eq 'assembly') && $form->{l_lastcost}) {
+  if ($form->{l_assembly} && $form->{l_lastcost}) {
     @simple_l_switches = grep { $_ ne 'lastcost' } @simple_l_switches;
   }
 
@@ -378,9 +380,14 @@ sub all_parts {
   }
 
   for ($form->{searchitems}) {
-    push @where_tokens, "p.part_type = 'part'"     if /part/;
-    push @where_tokens, "p.part_type = 'service'"  if /service/;
-    push @where_tokens, "p.part_type = 'assembly'" if /assembly/;
+    push @where_tokens, "p.part_type = 'part'"       if /part/;
+    push @where_tokens, "p.part_type = 'service'"    if /service/;
+    push @where_tokens, "p.part_type = 'assembly'"   if /assembly/;
+    push @where_tokens, "p.part_type = 'assortment'" if /assortment/;
+  }
+  if ( $form->{classification_id} > 0 ) {
+    push @where_tokens, "p.classification_id = ?";
+    push @bind_vars, $form->{classification_id};
   }
 
   for ($form->{itemstatus}) {
@@ -438,7 +445,7 @@ sub all_parts {
 
   push @select_tokens, @qsooqr_flags, 'quotation', 'cv', 'ioi.id', 'ioi.ioi'  if $bsooqr;
   push @select_tokens, @deliverydate_flags                                    if $bsooqr && $form->{l_deliverydate};
-  push @select_tokens, $q_assembly_lastcost                                   if ($form->{searchitems} eq 'assembly') && $form->{l_lastcost};
+  push @select_tokens, $q_assembly_lastcost                                   if $form->{l_assembly} && $form->{l_lastcost};
   push @bsooqr_tokens, q|module = 'ir' AND NOT ioi.assemblyitem|              if $form->{bought};
   push @bsooqr_tokens, q|module = 'is' AND NOT ioi.assemblyitem|              if $form->{sold};
   push @bsooqr_tokens, q|module = 'oe' AND NOT quotation AND cv = 'customer'| if $form->{ordered};
@@ -536,7 +543,7 @@ sub all_parts {
   # post processing for assembly parts lists (bom)
   # for each part get the assembly parts and add them into the partlist.
   my @assemblies;
-  if ($form->{searchitems} eq 'assembly' && $form->{bom}) {
+  if ($form->{l_assembly} && $form->{bom}) {
     $query =
       qq|SELECT p.id, p.partnumber, p.description, a.qty AS onhand,
            p.unit, p.notes, p.itime::DATE as insertdate,
@@ -583,8 +590,7 @@ SQL
       }
       $sth->finish;
     }
-  };
-
+  }
 
   $main::lxdebug->leave_sub();
 
@@ -815,7 +821,8 @@ sub get_parts {
   }
 
   my $query =
-    qq|SELECT id, partnumber, description, unit, sellprice
+    qq|SELECT id, partnumber, description, unit, sellprice,
+       classification_id
        FROM parts
        WHERE $where ORDER BY $order|;
 
@@ -828,6 +835,8 @@ sub get_parts {
     }
 
     $j++;
+    $form->{"type_and_classific_$j"} = $::request->presenter->type_abbreviation($ref->{part_type}).
+                                       $::request->presenter->classification_abbreviation($ref->{classification_id});
     $form->{"id_$j"}          = $ref->{id};
     $form->{"partnumber_$j"}  = $ref->{partnumber};
     $form->{"description_$j"} = $ref->{description};
@@ -1122,12 +1131,14 @@ sub prepare_parts_for_printing {
   for my $i (1..$rowcount) {
     my $id = $form->{"${prefix}${i}"};
     next unless $id;
-
-    push @{ $template_arrays{part_type} },  $parts_by_id{$id}->type;
+    my $prt = $parts_by_id{$id};
+    my $type_abbr = $::request->presenter->type_abbreviation($prt->part_type);
+    push @{ $template_arrays{part_type} }, $type_abbr;
+    push @{ $template_arrays{type_and_classific}},  $type_abbr.$::request->presenter->classification_abbreviation($prt->classification_id);
   }
 
-  return %template_arrays;
   $main::lxdebug->leave_sub();
+  return %template_arrays;
 }
 
 sub normalize_text_blocks {
diff --git a/SL/IR.pm b/SL/IR.pm
index 57cfb5a5f..f25aa921e 100644
--- a/SL/IR.pm
+++ b/SL/IR.pm
@@ -52,6 +52,9 @@ use SL::DB;
 use List::Util qw(min);
 
 use strict;
+use constant PCLASS_OK             =>   0;
+use constant PCLASS_NOTFORSALE     =>   1;
+use constant PCLASS_NOTFORPURCHASE =>   2;
 
 sub post_invoice {
   my ($self, $myconfig, $form, $provided_dbh, $payments_only) = @_;
@@ -1021,6 +1024,7 @@ sub retrieve_invoice {
         i.description, i.longdescription, i.qty, i.fxsellprice AS sellprice, i.parts_id AS id, i.unit, i.deliverydate, i.project_id, i.serialnumber,
         i.price_factor_id, i.price_factor, i.marge_price_factor, i.discount, i.active_price_source, i.active_discount_source,
         p.partnumber, p.part_type, pr.projectnumber, pg.partsgroup
+        ,p.classification_id
 
         FROM invoice i
         JOIN parts p ON (i.parts_id = p.id)
@@ -1280,6 +1284,7 @@ sub retrieve_item {
          p.notes AS partnotes, p.notes AS longdescription, p.not_discountable,
          p.price_factor_id,
          p.ean,
+         p.classification_id,
 
          pfac.factor AS price_factor,
 
@@ -1295,6 +1300,7 @@ sub retrieve_item {
          c3.new_chart_id                  AS expense_new_chart,
          date($transdate) - c3.valid_from AS expense_valid,
 
+         pt.used_for_purchase AS used_for_purchase,
          pg.partsgroup
 
        FROM parts p
@@ -1311,6 +1317,7 @@ sub retrieve_item {
            FROM taxzone_charts tc
            WHERE tc.taxzone_id = '$taxzone_id' and tc.buchungsgruppen_id = p.buchungsgruppen_id) = c3.id)
        LEFT JOIN partsgroup pg ON (pg.id = p.partsgroup_id)
+       LEFT JOIN part_classifications pt ON (pt.id = p.classification_id)
        LEFT JOIN price_factors pfac ON (pfac.id = p.price_factor_id)
        WHERE $where|;
   my $sth = prepare_execute_query($form, $dbh, $query, @values);
@@ -1329,6 +1336,7 @@ sub retrieve_item {
   map { push @{ $_ }, prepare_query($form, $dbh, $_->[0]) } @translation_queries;
 
   $form->{item_list} = [];
+  my $has_wrong_pclass = PCLASS_OK;
   while (my $ref = $sth->fetchrow_hashref("NAME_lc")) {
 
     if ($mm_by_id{$ref->{id}}) {
@@ -1339,7 +1347,13 @@ sub retrieve_item {
     if (($::form->{"partnumber_$i"} ne '') && ($ref->{ean} eq $::form->{"partnumber_$i"})) {
       push @{ $ref->{matches} ||= [] }, $::locale->text('EAN') . ': ' . $ref->{ean};
     }
+    $ref->{type_and_classific} = $::request->presenter->type_abbreviation($ref->{part_type}).
+                                 $::request->presenter->classification_abbreviation($ref->{classification_id});
 
+    if (! $ref->{used_for_purchase} ) {
+       $has_wrong_pclass = PCLASS_NOTFORPURCHASE;
+       next;
+    }
     # In der Buchungsgruppe ist immer ein Bestandskonto verknuepft, auch wenn
     # es sich um eine Dienstleistung handelt. Bei Dienstleistungen muss das
     # Buchungskonto also aus dem Ergebnis rausgenommen werden.
@@ -1409,12 +1423,15 @@ sub retrieve_item {
   $sth->finish();
   $_->[1]->finish for @translation_queries;
 
+  $form->{is_wrong_pclass} = $has_wrong_pclass;
+  $form->{NOTFORSALE}      = PCLASS_NOTFORSALE;
+  $form->{NOTFORPURCHASE}  = PCLASS_NOTFORPURCHASE;
   foreach my $item (@{ $form->{item_list} }) {
     my $custom_variables = CVar->get_custom_variables(module   => 'IC',
                                                       trans_id => $item->{id},
                                                       dbh      => $dbh,
                                                      );
-
+    $form->{is_wrong_pclass} = PCLASS_OK; # one correct type
     map { $item->{"ic_cvar_" . $_->{name} } = $_->{value} } @{ $custom_variables };
   }
 
